			<?php
			$this->lang->load('ps', 'english');
			?>
			<ul class="breadcrumb">
				<li><a href="<?php echo site_url(). "/dashboard";?>"><?php echo $this->lang->line('dashboard_label')?></a> <span class="divider"></span></li>
				<li><a href="<?php echo site_url('users');?>"><?php echo $this->lang->line('users_list_label')?></a> <span class="divider"></span></li>
				<li><?php echo $this->lang->line('update_user_label')?></li>
			</ul>
			
			<!-- Message -->
			<?php if($this->session->flashdata('success')): ?>
				<div class="alert alert-success fade in">
					<?php echo $this->session->flashdata('success');?>
					<button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
				</div>
			<?php elseif($this->session->flashdata('error')):?>
				<div class="alert alert-danger fade in">
					<?php echo $this->session->flashdata('error');?>
					<button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
				</div>
			<?php endif;?>

			<div id="perm_err" class="alert alert-danger fade in" style="display: none">
				<label for="permissions[]" class="error"></label>
				<button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
			</div>
			
			<div class="wrapper wrapper-content animated fadeInRight">
				<?php
				$attributes = array('id' => 'user-form');
				echo form_open(site_url('users/edit/'.$user->user_id), $attributes);
				?>
					<div class="row">
						<div class="col-sm-6">
							<legend><?php echo $this->lang->line('user_info_label')?></legend>
							
							<div class="form-group">
								<label><?php echo $this->lang->line('username_label')?></label>

								<?php echo form_input(array(
									'name' => 'user_name',
									'value' => html_entity_decode( $user->user_name ),
									'class' => 'form-control',
									'placeholder' => 'username',
									'id' => 'user_name'
								)); ?>

							</div>
							
							<div class="form-group">
								<label><?php echo $this->lang->line('email_label')?></label>

								<?php echo form_input(array(
									'name' => 'user_email',
									'value' => html_entity_decode( $user->user_email ),
									'class' => 'form-control',
									'placeholder' => 'email',
									'id' => 'user_email'
								)); ?>

							</div>
							
							<div class="form-group">
								<label><?php echo $this->lang->line('password_label')?></label>
								<input class="form-control" type="password" placeholder="password" name='user_password' id='user_password' >
							</div>
										
							<div class="form-group">
								<label><?php echo $this->lang->line('confirm_password_label')?></label>
								<input class="form-control" type="password" placeholder="confirm password" name='conf_password' id='conf_password'>
							</div>
							
							<div class="form-group">
								<label><?php echo $this->lang->line('user_role_label')?></label>
								<select class="form-control" name='role_id' id='role_id'>
									<?php
										foreach($this->role->get_all()->result() as $role){
											echo "<option value='".$role->role_id."' ";
											echo ($role->role_id == $user->role_id)? "selected":"";
											echo ">".$role->role_desc."</option>";
										}
									?>
								</select>
							</div>
							<hr>
							<div class="form-group">
								<label><?php echo $this->lang->line('select_shop_label')?></label> <br>
								<select class="form-control" name='shop_id' id='shop_id'>
									<?php
										foreach($this->shop->get_all()->result() as $shop)
											echo "<option value='".$shop->id."'>".$shop->name."</option>";
									?>
								</select>
							</div>
							
						</div>
						
						<div class="col-sm-6">
							<div class="form-group">
								<label class="control-label"><?php echo $this->lang->line('allowed_modules_label')?></label>
								<?php
									foreach($this->module->get_all()->result() as $module)
									{
										echo "<label class='checkbox'>";
										echo form_checkbox("permissions[]",$module->module_id,$this->user->has_permission($module->module_name,$user->user_id));
										echo $module->module_desc."</label><br/>";						
									}
								?>
							</div>
						</div>
					</div>
								
					
					<hr/>
					
					<button type="submit" class="btn btn-primary"><?php echo $this->lang->line('update_button')?></button>
					<a href="<?php echo site_url('users');?>" class="btn"><?php echo $this->lang->line('cancel_button')?></a>
				</form>
			</div>
			<script>
				$(document).ready(function(){
					$('#user-form').validate({
						rules:{
							user_name:{
								required: true,
								minlength: 4,
								remote: '<?php echo site_url('users/exists/'.$user->user_id);?>'
							},
							user_email:{
								required: true,
								email: true
							},
							user_password:{
								minlength: 4
							},
							conf_password:{
								equalTo: '#user_password'
							},
							"permissions[]": { 
								required: true, 
								minlength: 1 
							}
						},
						messages:{
							user_name:{
								required: "لطفا نام کاربری را پر کنید",
								minlength: "طول نام کاربری باید بیش از 4 باشد",
								remote: "نام کاربری در سیستم موجود است"
							},
							user_email:{
								required: "لطفا آدرس ایمیل را پر کنید",
								email: "لطفا آدرس ایمیل معتبر را ارائه دهید"
							},
							user_password:{
								minlength: "طول رمز عبور باید بیش از 4 باشد"
							},
							conf_password:{
								equalTo: "رمز عبور و تایید رمز عبور مطابقت ندارد"
							},
							"permissions[]": "لطفا انتخاب کنید که ماژول ها قادر به دسترسی هستند."
						},
						errorPlacement: function(error, element) {
							if (element.attr("name") == "permissions[]" ) {
								$("#perm_err label").html($(error).text());
								$("#perm_err").show();
							} else {
								error.insertAfter(element);
							}
						}
					});
				});
			</script>
