package ir.codenvato.mokets.activities;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Configuration;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.support.design.widget.CoordinatorLayout;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.text.Editable;
import android.text.SpannableString;
import android.util.Log;
import android.view.View;
import android.view.animation.AnimationUtils;
import android.widget.EditText;
import android.widget.Toast;

//import com.afollestad.materialdialogs.MaterialDialog;
import ir.codenvato.mokets.Config;
import ir.codenvato.mokets.GlobalData;
import ir.codenvato.mokets.models.BasketData;
import ir.codenvato.mokets.utilities.DBHandler;
import ir.codenvato.mokets.utilities.Utils;
import ir.codenvato.mokets.utilities.VolleySingleton;

import ir.codenvato.mokets.R;
import com.stripe.android.Stripe;
import com.stripe.android.TokenCallback;
import com.stripe.android.model.Card;
import com.stripe.android.exception.AuthenticationException;
import butterknife.ButterKnife;
import butterknife.OnTextChanged;
import ir.moslem_deris.apps.zarinpal.PaymentBuilder;
import ir.moslem_deris.apps.zarinpal.ZarinPal;
import ir.moslem_deris.apps.zarinpal.enums.ZarinPalError;
import ir.moslem_deris.apps.zarinpal.listeners.OnPaymentListener;
import ir.moslem_deris.apps.zarinpal.models.Payment;
import uk.co.chrisjenx.calligraphy.CalligraphyContextWrapper;

import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.VolleyLog;
import com.android.volley.toolbox.JsonObjectRequest;
import com.zarinpal.ewallets.purchase.OnCallbackRequestPaymentListener;
import com.zarinpal.ewallets.purchase.OnCallbackVerificationPaymentListener;
import com.zarinpal.ewallets.purchase.PaymentRequest;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

/**
 * Created by Panacea-Soft on 9/7/16.
 * Contact Email : teamps.is.cool@gmail.com
 */
public class StripeActivity extends AppCompatActivity{

    //-------------------------------------------------------------------------------------------------------------------------------------
    //region // Private Variables
    //-------------------------------------------------------------------------------------------------------------------------------------
    private Toolbar toolbar;
    private SpannableString stripeString;

    private static final int CARD_NUMBER_TOTAL_SYMBOLS = 19; // size of pattern 0000-0000-0000-0000
    private static final int CARD_NUMBER_TOTAL_DIGITS = 16; // max numbers of digits in pattern: 0000 x 4
    private static final int CARD_NUMBER_DIVIDER_MODULO = 5; // means divider position is every 5th symbol beginning with 1
    private static final int CARD_NUMBER_DIVIDER_POSITION = CARD_NUMBER_DIVIDER_MODULO - 1; // means divider position is every 4th symbol beginning with 0
    private static final char CARD_NUMBER_DIVIDER = '-';

    private static final int CARD_DATE_TOTAL_SYMBOLS = 5; // size of pattern MM/YY
    private static final int CARD_DATE_TOTAL_DIGITS = 4; // max numbers of digits in pattern: MM + YY
    private static final int CARD_DATE_DIVIDER_MODULO = 3; // means divider position is every 3rd symbol beginning with 1
    private static final int CARD_DATE_DIVIDER_POSITION = CARD_DATE_DIVIDER_MODULO - 1; // means divider position is every 2nd symbol beginning with 0
    private static final char CARD_DATE_DIVIDER = '/';

    private static final int CARD_CVC_TOTAL_SYMBOLS = 3;


    public static final String PUBLISHABLE_KEY = GlobalData.shopdata.stripe_publishable_key;
    public static final String API_KEY = GlobalData.shopdata.stripe_secret_key;

    private String URL = "";
    private String stripeToken;
    DBHandler db = new DBHandler(this);
    private List<BasketData> basket;
    private List<BasketData> basketDataSet;
    private String json_data = "";
    private String deliveryAddress = "";
    private String billingAddress = "";
    private String email = "";
    private String phone = "";
    private String word = "";

    //private RequestQueue mRequestQueue;
    private HashMap<String, String> params = new HashMap<String, String>();
    private EditText etCreditCard;
    private EditText etDate;
    private EditText etCVC;
    private Bundle bundle;
    private String jsonStatusSuccessString;
    private ProgressDialog prgDialog;
    private int selectedShopId;
    private CoordinatorLayout mainLayout;



    //-------------------------------------------------------------------------------------------------------------------------------------
    //endregion Private Variables
    //-------------------------------------------------------------------------------------------------------------------------------------

    //-------------------------------------------------------------------------------------------------------------------------------------
    //region // Override Functions
    //-------------------------------------------------------------------------------------------------------------------------------------

    @Override
    protected void attachBaseContext(Context newBase) {
        super.attachBaseContext(CalligraphyContextWrapper.wrap(newBase));
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //mRequestQueue = Volley.newRequestQueue(this);
        setContentView(R.layout.activity_stripe);
        Configuration configuration = getResources().getConfiguration();
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR1) {
            configuration.setLayoutDirection(new Locale("fa"));
        }
        ButterKnife.bind(this);

        Uri data = getIntent().getData();
        if (data== null){
            initData();
            initUI();
            bindData();
        }else {
            com.zarinpal.ewallets.purchase.ZarinPal.getPurchase(this).verificationPayment(data, new OnCallbackVerificationPaymentListener() {
                @Override
                public void onCallbackResultVerificationPayment(boolean isPaymentSuccess, String refID, PaymentRequest paymentRequest) {


                    if (isPaymentSuccess) {
                    /* When Payment Request is Success :) */

                        String message = "خرید شما با موفقیت انجام شد :) " + refID;

                        submitOrderToServer();
                        loadBasketData();
                       // final String URL = Config.APP_API_URL + Config.POST_STRIPE_TOKEN;
                       // Utils.psLog(URL);

                      //  HashMap<String, String> params = new HashMap<>();
                      //  params.put("stripeToken", String.valueOf("123456"));
                      //  params.put("amount", String.valueOf(BasketActivity.totalAmount));
                      //  params.put("currency", GlobalData.shopdata.currency_short_form);
                      //  params.put("shopId", String.valueOf(selectedShopId));


                        doSubmit(URL, params);
                        Toast.makeText(getApplicationContext(), message, Toast.LENGTH_SHORT).show();
                    } else {
                    /* When Payment Request is Failure :) */
                        String message = "خرید شما انجام نشد :(";
                        Toast.makeText(getApplicationContext(), message, Toast.LENGTH_SHORT).show();
                    }


                }
            });

        }

    }




    @Override
    public void onDestroy() {
        try {
            toolbar = null;
            prgDialog.cancel();
            prgDialog = null;

            Utils.unbindDrawables(mainLayout);
            mainLayout = null;

            super.onDestroy();
        }catch (Exception e){
            super.onDestroy();
        }
    }


    //-------------------------------------------------------------------------------------------------------------------------------------
    //endregion Override Functions
    //-------------------------------------------------------------------------------------------------------------------------------------

    //-------------------------------------------------------------------------------------------------------------------------------------
    //region // Init Data Functions
    //-------------------------------------------------------------------------------------------------------------------------------------
    private void initData() {

        stripeString = Utils.getSpannableString(getString(R.string.title_stripe));
        jsonStatusSuccessString = getResources().getString(R.string.json_status_success);
        bundle = getIntent().getExtras();
        email = bundle.getString("user_email");
        phone = bundle.getString("user_phone");
        selectedShopId = getIntent().getIntExtra("selected_shop_id", 0);
        deliveryAddress = bundle.getString("user_delivery_address");
        billingAddress = bundle.getString("user_billing_address");

        loadBasketData();


    }
    //-------------------------------------------------------------------------------------------------------------------------------------
    //endregion init Data Functions
    //-------------------------------------------------------------------------------------------------------------------------------------

    //-------------------------------------------------------------------------------------------------------------------------------------
    //region // init UI Functions
    //-------------------------------------------------------------------------------------------------------------------------------------
    private void initUI() {

        initToolbar();
        initProgressDialog();

        mainLayout = (CoordinatorLayout) findViewById(R.id.coordinator_layout);
        mainLayout.startAnimation(AnimationUtils.loadAnimation(this, R.anim.fade_in));


    }

    private void initToolbar() {
        try {
            toolbar = (Toolbar) findViewById(R.id.toolbar);
            toolbar.setTitle("");
            setSupportActionBar(toolbar);
            toolbar.setNavigationOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    onBackPressed();
                }
            });
            if(getSupportActionBar() != null) {
                getSupportActionBar().setDisplayHomeAsUpEnabled(true);
            }
        } catch (Exception e) {
            Utils.psErrorLogE("Error in initToolbar.", e);
        }
    }

    private void initProgressDialog() {
        try {
            prgDialog = new ProgressDialog(this);
            prgDialog.setMessage("لطفا صبر کنید...");
            prgDialog.setCancelable(false);
        } catch (Exception e) {
            Utils.psErrorLogE("Error in initProgressDialog.", e);
        }
    }

    //-------------------------------------------------------------------------------------------------------------------------------------
    //endregion init UI Functions
    //-------------------------------------------------------------------------------------------------------------------------------------

    //-------------------------------------------------------------------------------------------------------------------------------------
    //region // Bind Data Functions
    //-------------------------------------------------------------------------------------------------------------------------------------
    private void bindData() {
        toolbar.setTitle(stripeString);
    }
    //-------------------------------------------------------------------------------------------------------------------------------------
    //endregion Bind Data Functions
    //-------------------------------------------------------------------------------------------------------------------------------------


    //-------------------------------------------------------------------------------------------------------------------------------------
    //region // Private Functions
    //-------------------------------------------------------------------------------------------------------------------------------------


    private boolean isInputCorrect(Editable s, int size, int dividerPosition, char divider) {
        boolean isCorrect = s.length() <= size;
        for (int i = 0; i < s.length(); i++) {
            if (i > 0 && (i + 1) % dividerPosition == 0) {
                isCorrect &= divider == s.charAt(i);
            } else {
                isCorrect &= Character.isDigit(s.charAt(i));
            }
        }
        return isCorrect;
    }

    private String concatString(char[] digits, int dividerPosition, char divider) {
        final StringBuilder formatted = new StringBuilder();

        for (int i = 0; i < digits.length; i++) {
            if (digits[i] != 0) {
                formatted.append(digits[i]);
                if ((i > 0) && (i < (digits.length - 1)) && (((i + 1) % dividerPosition) == 0)) {
                    formatted.append(divider);
                }
            }
        }

        return formatted.toString();
    }

    private char[] getDigitArray(final Editable s, final int size) {
        char[] digits = new char[size];
        int index = 0;
        for (int i = 0; i < s.length() && index < size; i++) {
            char current = s.charAt(i);
            if (Character.isDigit(current)) {
                digits[index] = current;
                index++;
            }
        }
        return digits;
    }

    private void submitOrderToServer1() {
//        prgDialog.show();
        URL = Config.APP_API_URL + Config.POST_TRANSACTIONS;
        Utils.psLog(" >>> here >>> " + URL);
        Utils.psLog(">> params >> " + params);

        JsonObjectRequest req = new JsonObjectRequest(URL, new JSONObject(params),
          new Response.Listener<JSONObject>() {
              @Override
              public void onResponse(JSONObject response) {
                  Utils.psLog(" sever resp : " + response);

                  try {
                      //  pb.setVisibility(view.GONE);

                      String status = response.getString("status");
                      if (status.equals(jsonStatusSuccessString)) {
                          Utils.psLog(status);
                          //Need to clear basket sqlite data
                          db.deleteBasketByShopId(selectedShopId);
                          db.deleteAttributeByShopId(selectedShopId);

                          showSuccessPopup();

                      } else {
                          showFailPopup();
                          Utils.psLog("Error in loading.");
                      }

                    //  prgDialog.cancel();

                  } catch (JSONException e) {
                      e.printStackTrace();
                  } catch (Exception e){
                      Utils.psErrorLog("Error in loading.", e);
                  }

              }
          }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                VolleyLog.e("Error: ", error.getMessage());
            }
        });

        req.setShouldCache(false);
        VolleySingleton.getInstance(this).addToRequestQueue(req);

    }

    public void submitOrderToServer() {
        URL = Config.APP_API_URL + Config.POST_TRANSACTIONS;
        Utils.psLog(" >>> here >>> " + URL);
        Utils.psLog(">> params >> " + params);

        JsonObjectRequest req = new JsonObjectRequest(URL, new JSONObject(params),
                new Response.Listener<JSONObject>() {
                    @Override
                    public void onResponse(JSONObject response) {
                       Utils.psLog(" sever resp : " + response);

                        try {
                            //  pb.setVisibility(view.GONE);

                            String status = response.getString("status");
                            if (status.equals(jsonStatusSuccessString)) {
                                Utils.psLog(status);
                                //Need to clear basket sqlite data
                                db.deleteBasketByShopId(selectedShopId);
                                db.deleteAttributeByShopId(selectedShopId);
                                //Need to close all activities and load home page
                                //closeActivities();

                                showSuccessPopup();

                            } else {
                                showFailPopup();
                                Utils.psLog("Error in loading.");
                            }

                          //  prgDialog.cancel();

                        } catch (JSONException e) {
                            e.printStackTrace();
                        } catch (Exception e){
                            Utils.psErrorLog("Error in loading.", e);
                        }

                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                VolleyLog.e("Error: ", error.getMessage());
            }
        });

        req.setShouldCache(false);
        VolleySingleton.getInstance(this).addToRequestQueue(req);

    }


    private void loadBasketData() {
        basketDataSet = new ArrayList<>();
        basketDataSet.clear();
        basket = db.getAllBasketDataByShopId(selectedShopId);

        JSONArray jsonArray = new JSONArray();

        JSONObject jsonObject = null;

        for (BasketData basketData : basket) {


            try {
                jsonObject = new JSONObject();

                jsonObject.put("item_id", String.valueOf(basketData.getItemId()));
                jsonObject.put("shop_id", String.valueOf(basketData.getShopId()));
                jsonObject.put("unit_price", basketData.getUnitPrice());
                jsonObject.put("discount_percent", basketData.getDiscountPercent());
                jsonObject.put("name", basketData.getName());
                jsonObject.put("qty", basketData.getQty());
                jsonObject.put("user_id", basketData.getUserId());
                jsonObject.put("payment_trans_id", "");
                jsonObject.put("delivery_address", deliveryAddress);
                jsonObject.put("billing_address", billingAddress);
                jsonObject.put("total_amount", BasketActivity.totalAmount);
                jsonObject.put("basket_item_attribute_id", basketData.getSelectedAttributeIds());
                jsonObject.put("basket_item_attribute", basketData.getSelectedAttributeNames());
                jsonObject.put("payment_method", "stripe");
                jsonObject.put("email", email);
                jsonObject.put("phone", phone);
                jsonObject.put("platform", "Android");

                jsonArray.put(jsonObject);
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e){
                Utils.psErrorLog("Error in loading.", e);
            }

        }


        JSONObject studentsObj = new JSONObject();
        String jsonStr = "";
        try {

            studentsObj.put("Orders", jsonArray);
            jsonStr = studentsObj.toString();
            Utils.psLog(" json >>> " + jsonStr);

            params.put("orders", jsonArray.toString());

        } catch (JSONException e) {
            e.printStackTrace();
        } catch (Exception e){
            Utils.psErrorLog("Error in loading.", e);
        }

        Utils.psLog(" >>> params >> " + params);

    }

    private void closeActivities() {
        Intent in = new Intent();
        in.putExtra("close_activity", "YES");
        setResult(RESULT_OK, in);
        finish();
        overridePendingTransition(R.anim.blank_anim, R.anim.left_to_right);
    }

    //-------------------------------------------------------------------------------------------------------------------------------------
    //endregion Private Functions
    //-------------------------------------------------------------------------------------------------------------------------------------

    //-------------------------------------------------------------------------------------------------------------------------------------
    //region // Public Functions
    //-------------------------------------------------------------------------------------------------------------------------------------

    public void doStripePayment(View view) throws AuthenticationException {

        pay();


       // if(etCreditCard.getText().toString().equals("") | etDate.getText().toString().equals("")) {

      //      Utils.psLog("Empty if");

     //   } else {
      //      prgDialog.show();
       //     if(etCVC.getText().toString().equals("")) {
       //         Utils.psLog("Empty");
       //     } else {

          //      String[] explodedDate = etDate.getText().toString().split("/");
          //      String year = "20" + explodedDate[1];


         //       Card card = new Card(etCreditCard.getText().toString(), Integer.parseInt(explodedDate[0]), Integer.parseInt(year), etCVC.getText().toString());


         //       if ( !card.validateCard() ) {
         //           Toast.makeText(this, "Invalid Credit Card", Toast.LENGTH_SHORT).show();
          //          return;
         //       }

          //      Stripe stripe = new Stripe(PUBLISHABLE_KEY);
          //      stripe.createToken(
          //              card,
           //             new TokenCallback() {
          //                  @Override
            //                public void onError(Exception e) {
            //                    // Show localized error message
             //                   Toast.makeText(StripeActivity.this,
             //                           e.getLocalizedMessage(),
             //                           Toast.LENGTH_LONG
              //                  ).show();
              //              }

                //            @Override
                  //          public void onSuccess(com.stripe.android.model.Token token) {
                  //              //chargeCustomer(token);

                  //              final String URL = Config.APP_API_URL + Config.POST_STRIPE_TOKEN;
                    //            Utils.psLog(URL);

                        //        HashMap<String, String> params = new HashMap<>();
                        //       params.put("stripeToken", String.valueOf(token.getId()));
                        //        params.put("amount", String.valueOf(BasketActivity.totalAmount));
                        //        params.put("currency", GlobalData.shopdata.currency_short_form);
                        //        params.put("shopId", String.valueOf(selectedShopId));


                         //       doSubmit(URL, params);
                          //  }

                            /*
                            public void chargeCustomer(com.stripe.android.model.Token token) {
                                final Map<String, Object> chargeParams = new HashMap<String, Object>();
                                chargeParams.put("amount", (int) (BasketActivity.totalAmount * 100));
                                chargeParams.put("currency", GlobalData.shopdata.currency_short_form.toLowerCase());
                                chargeParams.put("card", token.getId());
                                chargeParams.put("description", "Mokets Order From Android");
                                Utils.psLog("token : " + token.getId());
                                new AsyncTask<Void, Void, Void>() {

                                    Charge charge;

                                    @Override
                                    protected Void doInBackground(Void... params) {
                                        try {
                                            com.stripe.Stripe.apiKey = API_KEY;
                                            charge = Charge.create(chargeParams);

                                        } catch (Exception e) {
                                            // TODO Auto-generated catch block
                                            e.printStackTrace();
                                        }
                                        return null;
                                    }

                                    protected void onPostExecute(Void result) {
                                        submitOrderToServer();
                                    };

                                }.execute();
                            }
                            */


                 //       }
              //  );

           // }

      //  }



    }

    private void pay(){
        com.zarinpal.ewallets.purchase.ZarinPal purchase = com.zarinpal.ewallets.purchase.ZarinPal.getPurchase(this);
        PaymentRequest payment  = com.zarinpal.ewallets.purchase.ZarinPal.getPaymentRequest();
        word = BasketActivity.totalAmount.toString();
        word = word.replace("مبلغ کل :","");  //اگر در سمت سرور نوع ارز را ریال انتخاب کرده اید اینجا بجای تومان ریال بنویسید
        word = word.replace("تومان(تومان)","");
        double test = Double.parseDouble(word);
        int qeymat = (int) test;
        payment.setMerchantID("fd283808-408f-11e6-af87-000c295eb8fc");
        payment.setAmount(qeymat);
        payment.setDescription("فروشگاه کد انواتو");
        payment.setCallbackURL("retuern://zarinpalpayment");     /* Your App Scheme */
        payment.setMobile(phone);            /* Optional Parameters */
        payment.setEmail(email);     /* Optional Parameters */


        purchase.startPayment(payment, new OnCallbackRequestPaymentListener() {
            @Override
            public void onCallbackResultPaymentRequest(int status, String authority, Uri paymentGatewayUri, Intent intent) {


                if (status == 100) {
                    /*
                    When Status is 100 Open Zarinpal PG on Browser
                    */
                   // loadBasketData();
                    startActivity(intent);
                } else {
                    Toast.makeText(getApplicationContext(), "خرید شما انجام نشد :(", Toast.LENGTH_LONG).show();
                }

            }
        });
    }

    public void doSubmit(String URL, final HashMap<String, String> params) {
        Utils.psLog("Stripe Params " + params);
//        prgDialog.show();
        JsonObjectRequest req = new JsonObjectRequest(URL, new JSONObject(params),
                new Response.Listener<JSONObject>() {
                    @Override
                    public void onResponse(JSONObject response) {
                        prgDialog.cancel();
                        try {
                            //  pb.setVisibility(view.GONE);

                            String status = response.getString("status");
                            if (status.equals(jsonStatusSuccessString)) {
                                Utils.psLog(status);
                                submitOrderToServer();

                            } else {
                                showFailPopup();
                                Utils.psLog("Error in loading.");
                            }

                            prgDialog.cancel();

                        } catch (JSONException e) {
                            e.printStackTrace();
                        } catch (Exception e){
                            Utils.psErrorLog("Error in loading.", e);
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                VolleyLog.e("Error: ", error.getMessage());
            }
        });

        req.setShouldCache(false);
        VolleySingleton.getInstance(this).addToRequestQueue(req);
    }

    public void showSuccessPopup() {
        AlertDialog.Builder builder =
          new AlertDialog.Builder(this, R.style.AppCompatAlertDialogStyle);
        builder.setTitle(R.string.order_submit_title);
        builder.setMessage(R.string.order_success);
        builder.setPositiveButton(R.string.OK, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                closeActivities();
                Utils.psLog("OK clicked.");
            }
        });
        builder.show();
    }

    public void showFailPopup() {
        AlertDialog.Builder builder =
          new AlertDialog.Builder(this, R.style.AppCompatAlertDialogStyle);
        builder.setTitle(R.string.order_submit_title);
        builder.setMessage(R.string.order_fail);
        builder.setPositiveButton(R.string.OK, null);
        builder.show();
    }

    //-------------------------------------------------------------------------------------------------------------------------------------
    //endregion Public Functions
    //-------------------------------------------------------------------------------------------------------------------------------------


}
